package java.awt;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.ContainerEvent;
import java.awt.event.ContainerListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.HierarchyBoundsListener;
import java.awt.event.HierarchyEvent;
import java.awt.event.HierarchyListener;
import java.awt.event.InputMethodEvent;
import java.awt.event.InputMethodListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.TextEvent;
import java.awt.event.TextListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.lang.reflect.Array;
import java.util.EventListener;

public class AWTEventMulticaster implements ComponentListener, ContainerListener, FocusListener, KeyListener, MouseListener, MouseMotionListener, WindowListener, ActionListener, ItemListener, AdjustmentListener, TextListener, InputMethodListener, HierarchyListener, HierarchyBoundsListener {
   // $FF: renamed from: a java.util.EventListener
   protected final EventListener field_0;
   // $FF: renamed from: b java.util.EventListener
   protected final EventListener field_1;

   protected AWTEventMulticaster(EventListener var1, EventListener var2) {
      this.field_0 = var1;
      this.field_1 = var2;
   }

   protected EventListener remove(EventListener var1) {
      if (var1 == this.field_0) {
         return this.field_1;
      } else if (var1 == this.field_1) {
         return this.field_0;
      } else {
         EventListener var2 = removeInternal(this.field_0, var1);
         EventListener var3 = removeInternal(this.field_1, var1);
         return (EventListener)(var2 == this.field_0 && var3 == this.field_1 ? this : addInternal(var2, var3));
      }
   }

   public void componentResized(ComponentEvent var1) {
      ((ComponentListener)this.field_0).componentResized(var1);
      ((ComponentListener)this.field_1).componentResized(var1);
   }

   public void componentMoved(ComponentEvent var1) {
      ((ComponentListener)this.field_0).componentMoved(var1);
      ((ComponentListener)this.field_1).componentMoved(var1);
   }

   public void componentShown(ComponentEvent var1) {
      ((ComponentListener)this.field_0).componentShown(var1);
      ((ComponentListener)this.field_1).componentShown(var1);
   }

   public void componentHidden(ComponentEvent var1) {
      ((ComponentListener)this.field_0).componentHidden(var1);
      ((ComponentListener)this.field_1).componentHidden(var1);
   }

   public void componentAdded(ContainerEvent var1) {
      ((ContainerListener)this.field_0).componentAdded(var1);
      ((ContainerListener)this.field_1).componentAdded(var1);
   }

   public void componentRemoved(ContainerEvent var1) {
      ((ContainerListener)this.field_0).componentRemoved(var1);
      ((ContainerListener)this.field_1).componentRemoved(var1);
   }

   public void focusGained(FocusEvent var1) {
      ((FocusListener)this.field_0).focusGained(var1);
      ((FocusListener)this.field_1).focusGained(var1);
   }

   public void focusLost(FocusEvent var1) {
      ((FocusListener)this.field_0).focusLost(var1);
      ((FocusListener)this.field_1).focusLost(var1);
   }

   public void keyTyped(KeyEvent var1) {
      ((KeyListener)this.field_0).keyTyped(var1);
      ((KeyListener)this.field_1).keyTyped(var1);
   }

   public void keyPressed(KeyEvent var1) {
      ((KeyListener)this.field_0).keyPressed(var1);
      ((KeyListener)this.field_1).keyPressed(var1);
   }

   public void keyReleased(KeyEvent var1) {
      ((KeyListener)this.field_0).keyReleased(var1);
      ((KeyListener)this.field_1).keyReleased(var1);
   }

   public void mouseClicked(MouseEvent var1) {
      ((MouseListener)this.field_0).mouseClicked(var1);
      ((MouseListener)this.field_1).mouseClicked(var1);
   }

   public void mousePressed(MouseEvent var1) {
      ((MouseListener)this.field_0).mousePressed(var1);
      ((MouseListener)this.field_1).mousePressed(var1);
   }

   public void mouseReleased(MouseEvent var1) {
      ((MouseListener)this.field_0).mouseReleased(var1);
      ((MouseListener)this.field_1).mouseReleased(var1);
   }

   public void mouseEntered(MouseEvent var1) {
      ((MouseListener)this.field_0).mouseEntered(var1);
      ((MouseListener)this.field_1).mouseEntered(var1);
   }

   public void mouseExited(MouseEvent var1) {
      ((MouseListener)this.field_0).mouseExited(var1);
      ((MouseListener)this.field_1).mouseExited(var1);
   }

   public void mouseDragged(MouseEvent var1) {
      ((MouseMotionListener)this.field_0).mouseDragged(var1);
      ((MouseMotionListener)this.field_1).mouseDragged(var1);
   }

   public void mouseMoved(MouseEvent var1) {
      ((MouseMotionListener)this.field_0).mouseMoved(var1);
      ((MouseMotionListener)this.field_1).mouseMoved(var1);
   }

   public void windowOpened(WindowEvent var1) {
      ((WindowListener)this.field_0).windowOpened(var1);
      ((WindowListener)this.field_1).windowOpened(var1);
   }

   public void windowClosing(WindowEvent var1) {
      ((WindowListener)this.field_0).windowClosing(var1);
      ((WindowListener)this.field_1).windowClosing(var1);
   }

   public void windowClosed(WindowEvent var1) {
      ((WindowListener)this.field_0).windowClosed(var1);
      ((WindowListener)this.field_1).windowClosed(var1);
   }

   public void windowIconified(WindowEvent var1) {
      ((WindowListener)this.field_0).windowIconified(var1);
      ((WindowListener)this.field_1).windowIconified(var1);
   }

   public void windowDeiconified(WindowEvent var1) {
      ((WindowListener)this.field_0).windowDeiconified(var1);
      ((WindowListener)this.field_1).windowDeiconified(var1);
   }

   public void windowActivated(WindowEvent var1) {
      ((WindowListener)this.field_0).windowActivated(var1);
      ((WindowListener)this.field_1).windowActivated(var1);
   }

   public void windowDeactivated(WindowEvent var1) {
      ((WindowListener)this.field_0).windowDeactivated(var1);
      ((WindowListener)this.field_1).windowDeactivated(var1);
   }

   public void actionPerformed(ActionEvent var1) {
      ((ActionListener)this.field_0).actionPerformed(var1);
      ((ActionListener)this.field_1).actionPerformed(var1);
   }

   public void itemStateChanged(ItemEvent var1) {
      ((ItemListener)this.field_0).itemStateChanged(var1);
      ((ItemListener)this.field_1).itemStateChanged(var1);
   }

   public void adjustmentValueChanged(AdjustmentEvent var1) {
      ((AdjustmentListener)this.field_0).adjustmentValueChanged(var1);
      ((AdjustmentListener)this.field_1).adjustmentValueChanged(var1);
   }

   public void textValueChanged(TextEvent var1) {
      ((TextListener)this.field_0).textValueChanged(var1);
      ((TextListener)this.field_1).textValueChanged(var1);
   }

   public void inputMethodTextChanged(InputMethodEvent var1) {
      ((InputMethodListener)this.field_0).inputMethodTextChanged(var1);
      ((InputMethodListener)this.field_1).inputMethodTextChanged(var1);
   }

   public void caretPositionChanged(InputMethodEvent var1) {
      ((InputMethodListener)this.field_0).caretPositionChanged(var1);
      ((InputMethodListener)this.field_1).caretPositionChanged(var1);
   }

   public void hierarchyChanged(HierarchyEvent var1) {
      ((HierarchyListener)this.field_0).hierarchyChanged(var1);
      ((HierarchyListener)this.field_1).hierarchyChanged(var1);
   }

   public void ancestorMoved(HierarchyEvent var1) {
      ((HierarchyBoundsListener)this.field_0).ancestorMoved(var1);
      ((HierarchyBoundsListener)this.field_1).ancestorMoved(var1);
   }

   public void ancestorResized(HierarchyEvent var1) {
      ((HierarchyBoundsListener)this.field_0).ancestorResized(var1);
      ((HierarchyBoundsListener)this.field_1).ancestorResized(var1);
   }

   public static ComponentListener add(ComponentListener var0, ComponentListener var1) {
      return (ComponentListener)addInternal(var0, var1);
   }

   public static ContainerListener add(ContainerListener var0, ContainerListener var1) {
      return (ContainerListener)addInternal(var0, var1);
   }

   public static FocusListener add(FocusListener var0, FocusListener var1) {
      return (FocusListener)addInternal(var0, var1);
   }

   public static KeyListener add(KeyListener var0, KeyListener var1) {
      return (KeyListener)addInternal(var0, var1);
   }

   public static MouseListener add(MouseListener var0, MouseListener var1) {
      return (MouseListener)addInternal(var0, var1);
   }

   public static MouseMotionListener add(MouseMotionListener var0, MouseMotionListener var1) {
      return (MouseMotionListener)addInternal(var0, var1);
   }

   public static WindowListener add(WindowListener var0, WindowListener var1) {
      return (WindowListener)addInternal(var0, var1);
   }

   public static ActionListener add(ActionListener var0, ActionListener var1) {
      return (ActionListener)addInternal(var0, var1);
   }

   public static ItemListener add(ItemListener var0, ItemListener var1) {
      return (ItemListener)addInternal(var0, var1);
   }

   public static AdjustmentListener add(AdjustmentListener var0, AdjustmentListener var1) {
      return (AdjustmentListener)addInternal(var0, var1);
   }

   public static TextListener add(TextListener var0, TextListener var1) {
      return (TextListener)addInternal(var0, var1);
   }

   public static InputMethodListener add(InputMethodListener var0, InputMethodListener var1) {
      return (InputMethodListener)addInternal(var0, var1);
   }

   public static HierarchyListener add(HierarchyListener var0, HierarchyListener var1) {
      return (HierarchyListener)addInternal(var0, var1);
   }

   public static HierarchyBoundsListener add(HierarchyBoundsListener var0, HierarchyBoundsListener var1) {
      return (HierarchyBoundsListener)addInternal(var0, var1);
   }

   public static ComponentListener remove(ComponentListener var0, ComponentListener var1) {
      return (ComponentListener)removeInternal(var0, var1);
   }

   public static ContainerListener remove(ContainerListener var0, ContainerListener var1) {
      return (ContainerListener)removeInternal(var0, var1);
   }

   public static FocusListener remove(FocusListener var0, FocusListener var1) {
      return (FocusListener)removeInternal(var0, var1);
   }

   public static KeyListener remove(KeyListener var0, KeyListener var1) {
      return (KeyListener)removeInternal(var0, var1);
   }

   public static MouseListener remove(MouseListener var0, MouseListener var1) {
      return (MouseListener)removeInternal(var0, var1);
   }

   public static MouseMotionListener remove(MouseMotionListener var0, MouseMotionListener var1) {
      return (MouseMotionListener)removeInternal(var0, var1);
   }

   public static WindowListener remove(WindowListener var0, WindowListener var1) {
      return (WindowListener)removeInternal(var0, var1);
   }

   public static ActionListener remove(ActionListener var0, ActionListener var1) {
      return (ActionListener)removeInternal(var0, var1);
   }

   public static ItemListener remove(ItemListener var0, ItemListener var1) {
      return (ItemListener)removeInternal(var0, var1);
   }

   public static AdjustmentListener remove(AdjustmentListener var0, AdjustmentListener var1) {
      return (AdjustmentListener)removeInternal(var0, var1);
   }

   public static TextListener remove(TextListener var0, TextListener var1) {
      return (TextListener)removeInternal(var0, var1);
   }

   public static InputMethodListener remove(InputMethodListener var0, InputMethodListener var1) {
      return (InputMethodListener)removeInternal(var0, var1);
   }

   public static HierarchyListener remove(HierarchyListener var0, HierarchyListener var1) {
      return (HierarchyListener)removeInternal(var0, var1);
   }

   public static HierarchyBoundsListener remove(HierarchyBoundsListener var0, HierarchyBoundsListener var1) {
      return (HierarchyBoundsListener)removeInternal(var0, var1);
   }

   protected static EventListener addInternal(EventListener var0, EventListener var1) {
      if (var0 == null) {
         return var1;
      } else {
         return (EventListener)(var1 == null ? var0 : new AWTEventMulticaster(var0, var1));
      }
   }

   protected static EventListener removeInternal(EventListener var0, EventListener var1) {
      if (var0 != var1 && var0 != null) {
         return var0 instanceof AWTEventMulticaster ? ((AWTEventMulticaster)var0).remove(var1) : var0;
      } else {
         return null;
      }
   }

   protected void saveInternal(ObjectOutputStream var1, String var2) throws IOException {
      if (this.field_0 instanceof AWTEventMulticaster) {
         ((AWTEventMulticaster)this.field_0).saveInternal(var1, var2);
      } else if (this.field_0 instanceof Serializable) {
         var1.writeObject(var2);
         var1.writeObject(this.field_0);
      }

      if (this.field_1 instanceof AWTEventMulticaster) {
         ((AWTEventMulticaster)this.field_1).saveInternal(var1, var2);
      } else if (this.field_1 instanceof Serializable) {
         var1.writeObject(var2);
         var1.writeObject(this.field_1);
      }

   }

   protected static void save(ObjectOutputStream var0, String var1, EventListener var2) throws IOException {
      if (var2 != null) {
         if (var2 instanceof AWTEventMulticaster) {
            ((AWTEventMulticaster)var2).saveInternal(var0, var1);
         } else if (var2 instanceof Serializable) {
            var0.writeObject(var1);
            var0.writeObject(var2);
         }

      }
   }

   private static int getListenerCount(EventListener var0) {
      if (var0 instanceof AWTEventMulticaster) {
         AWTEventMulticaster var1 = (AWTEventMulticaster)var0;
         return getListenerCount(var1.field_0) + getListenerCount(var1.field_1);
      } else {
         return var0 == null ? 0 : 1;
      }
   }

   private static int populateListenerArray(EventListener[] var0, EventListener var1, int var2) {
      if (var1 instanceof AWTEventMulticaster) {
         AWTEventMulticaster var3 = (AWTEventMulticaster)var1;
         int var4 = populateListenerArray(var0, var3.field_0, var2);
         return populateListenerArray(var0, var3.field_1, var4);
      } else if (var1 != null) {
         var0[var2] = var1;
         return var2 + 1;
      } else {
         return var2;
      }
   }

   static EventListener[] getListeners(EventListener var0, Class var1) {
      int var2 = getListenerCount(var0);
      EventListener[] var3 = (EventListener[])Array.newInstance(var1, var2);
      populateListenerArray(var3, var0, 0);
      return var3;
   }
}
