package java.awt;

import javax.accessibility.Accessible;
import javax.accessibility.AccessibleContext;

public class Canvas extends Component implements Accessible {
   private static final String base = "canvas";
   private static int nameCounter = 0;
   private static final long serialVersionUID = -2284879212465893870L;

   public Canvas() {
   }

   public Canvas(GraphicsConfiguration var1) {
      this();
      super.graphicsConfig = var1;
   }

   String constructComponentName() {
      Class var1 = this.getClass();
      synchronized(var1) {
         String var2 = "canvas" + nameCounter++;
         return var2;
      }
   }

   public void addNotify() {
      Object var1 = ((Component)this).getTreeLock();
      synchronized(var1) {
         if (super.peer == null) {
            super.peer = ((Component)this).getToolkit().createCanvas(this);
         }

         super.addNotify();
      }
   }

   public void paint(Graphics var1) {
      var1.setColor(((Component)this).getBackground());
      var1.fillRect(0, 0, super.width, super.height);
   }

   boolean postsOldMouseEvents() {
      return true;
   }

   public AccessibleContext getAccessibleContext() {
      if (super.accessibleContext == null) {
         super.accessibleContext = new AccessibleAWTCanvas(this);
      }

      return super.accessibleContext;
   }
}
