package java.awt;

import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;

public abstract class GraphicsConfiguration {
   protected GraphicsConfiguration() {
   }

   public abstract GraphicsDevice getDevice();

   public abstract BufferedImage createCompatibleImage(int var1, int var2);

   public abstract BufferedImage createCompatibleImage(int var1, int var2, int var3);

   public abstract ColorModel getColorModel();

   public abstract ColorModel getColorModel(int var1);

   public abstract AffineTransform getDefaultTransform();

   public abstract AffineTransform getNormalizingTransform();

   public abstract Rectangle getBounds();
}
