package java.awt;

import java.awt.image.BufferedImage;
import java.security.AccessController;
import java.util.Locale;
import sun.security.action.GetPropertyAction;

public abstract class GraphicsEnvironment {
   private static GraphicsEnvironment localEnv;

   protected GraphicsEnvironment() {
   }

   public static synchronized GraphicsEnvironment getLocalGraphicsEnvironment() {
      if (localEnv == null) {
         String var0 = (String)AccessController.doPrivileged(new GetPropertyAction("java.awt.graphicsenv", (String)null));

         try {
            localEnv = (GraphicsEnvironment)Class.forName(var0).newInstance();
         } catch (ClassNotFoundException var4) {
            throw new Error("Could not find class: " + var0);
         } catch (InstantiationException var5) {
            throw new Error("Could not instantiate Graphics Environment: " + var0);
         } catch (IllegalAccessException var6) {
            throw new Error("Could not access Graphics Environment: " + var0);
         }
      }

      return localEnv;
   }

   public abstract GraphicsDevice[] getScreenDevices();

   public abstract GraphicsDevice getDefaultScreenDevice();

   public abstract Graphics2D createGraphics(BufferedImage var1);

   public abstract Font[] getAllFonts();

   public abstract String[] getAvailableFontFamilyNames();

   public abstract String[] getAvailableFontFamilyNames(Locale var1);
}
