package java.awt;

import java.awt.image.AreaAveragingScaleFilter;
import java.awt.image.FilteredImageSource;
import java.awt.image.ImageFilter;
import java.awt.image.ImageObserver;
import java.awt.image.ImageProducer;
import java.awt.image.ReplicateScaleFilter;

public abstract class Image {
   public static final Object UndefinedProperty = new Object();
   public static final int SCALE_DEFAULT = 1;
   public static final int SCALE_FAST = 2;
   public static final int SCALE_SMOOTH = 4;
   public static final int SCALE_REPLICATE = 8;
   public static final int SCALE_AREA_AVERAGING = 16;

   public abstract int getWidth(ImageObserver var1);

   public abstract int getHeight(ImageObserver var1);

   public abstract ImageProducer getSource();

   public abstract Graphics getGraphics();

   public abstract Object getProperty(String var1, ImageObserver var2);

   public Image getScaledInstance(int var1, int var2, int var3) {
      Object var4;
      if ((var3 & 20) != 0) {
         var4 = new AreaAveragingScaleFilter(var1, var2);
      } else {
         var4 = new ReplicateScaleFilter(var1, var2);
      }

      FilteredImageSource var5 = new FilteredImageSource(this.getSource(), (ImageFilter)var4);
      return Toolkit.getDefaultToolkit().createImage(var5);
   }

   public abstract void flush();
}
