package java.awt;

import javax.accessibility.Accessible;
import javax.accessibility.AccessibleContext;

public class Panel extends Container implements Accessible {
   private static final String base = "panel";
   private static int nameCounter = 0;
   private static final long serialVersionUID = -2728009084054400034L;

   public Panel() {
      this(new FlowLayout());
   }

   public Panel(LayoutManager var1) {
      ((Container)this).setLayout(var1);
   }

   String constructComponentName() {
      Class var1 = this.getClass();
      synchronized(var1) {
         String var2 = "panel" + nameCounter++;
         return var2;
      }
   }

   public void addNotify() {
      Object var1 = ((Component)this).getTreeLock();
      synchronized(var1) {
         if (super.peer == null) {
            super.peer = ((Component)this).getToolkit().createPanel(this);
         }

         super.addNotify();
      }
   }

   public AccessibleContext getAccessibleContext() {
      if (super.accessibleContext == null) {
         super.accessibleContext = new AccessibleAWTPanel(this);
      }

      return super.accessibleContext;
   }
}
