package java.awt;

import java.awt.peer.PopupMenuPeer;
import javax.accessibility.AccessibleContext;

public class PopupMenu extends Menu {
   private static final String base = "popup";
   static int nameCounter = 0;
   private static final long serialVersionUID = -4620452533522760060L;

   public PopupMenu() {
      this("");
   }

   public PopupMenu(String var1) {
      super(var1);
   }

   String constructComponentName() {
      Class var1 = this.getClass();
      synchronized(var1) {
         String var2 = "popup" + nameCounter++;
         return var2;
      }
   }

   public void addNotify() {
      Object var1 = ((MenuComponent)this).getTreeLock();
      synchronized(var1) {
         if (super.parent != null && !(super.parent instanceof Component)) {
            super.addNotify();
         } else {
            if (super.peer == null) {
               super.peer = Toolkit.getDefaultToolkit().createPopupMenu(this);
            }

            int var2 = ((Menu)this).getItemCount();

            for(int var3 = 0; var3 < var2; ++var3) {
               MenuItem var4 = ((Menu)this).getItem(var3);
               var4.parent = this;
               var4.addNotify();
            }
         }

      }
   }

   public void show(Component var1, int var2, int var3) {
      MenuContainer var4 = super.parent;
      if (var4 == null) {
         throw new NullPointerException("parent is null");
      } else if (!(var4 instanceof Component)) {
         throw new IllegalArgumentException("PopupMenus with non-Component parents cannot be shown");
      } else {
         Component var5 = (Component)var4;
         if (var5 != var1 && var5 instanceof Container && !((Container)var5).isAncestorOf(var1)) {
            throw new IllegalArgumentException("origin not in parent's hierarchy");
         } else if (var5.getPeer() != null && var5.isShowing()) {
            if (super.peer == null) {
               this.addNotify();
            }

            Object var6 = ((MenuComponent)this).getTreeLock();
            synchronized(var6) {
               if (super.peer != null) {
                  ((PopupMenuPeer)super.peer).show(new Event(var1, 0L, 501, var2, var3, 0, 0));
               }

            }
         } else {
            throw new RuntimeException("parent not showing on screen");
         }
      }
   }

   public AccessibleContext getAccessibleContext() {
      if (super.accessibleContext == null) {
         super.accessibleContext = new AccessibleAWTPopupMenu(this);
      }

      return super.accessibleContext;
   }
}
