package java.awt;

import java.awt.geom.Rectangle2D;
import java.io.Serializable;

public class Rectangle extends Rectangle2D implements Shape, Serializable {
   // $FF: renamed from: x int
   public int field_0;
   // $FF: renamed from: y int
   public int field_1;
   public int width;
   public int height;
   private static final long serialVersionUID = -4345857070255674764L;

   private static native void initIDs();

   public Rectangle() {
      this(0, 0, 0, 0);
   }

   public Rectangle(Rectangle var1) {
      this(var1.field_0, var1.field_1, var1.width, var1.height);
   }

   public Rectangle(int var1, int var2, int var3, int var4) {
      this.field_0 = var1;
      this.field_1 = var2;
      this.width = var3;
      this.height = var4;
   }

   public Rectangle(int var1, int var2) {
      this(0, 0, var1, var2);
   }

   public Rectangle(Point var1, Dimension var2) {
      this(var1.x, var1.y, var2.width, var2.height);
   }

   public Rectangle(Point var1) {
      this(var1.x, var1.y, 0, 0);
   }

   public Rectangle(Dimension var1) {
      this(0, 0, var1.width, var1.height);
   }

   public double getX() {
      return (double)this.field_0;
   }

   public double getY() {
      return (double)this.field_1;
   }

   public double getWidth() {
      return (double)this.width;
   }

   public double getHeight() {
      return (double)this.height;
   }

   public Rectangle getBounds() {
      return new Rectangle(this.field_0, this.field_1, this.width, this.height);
   }

   public Rectangle2D getBounds2D() {
      return new Rectangle(this.field_0, this.field_1, this.width, this.height);
   }

   public void setBounds(Rectangle var1) {
      this.setBounds(var1.field_0, var1.field_1, var1.width, var1.height);
   }

   public void setBounds(int var1, int var2, int var3, int var4) {
      this.reshape(var1, var2, var3, var4);
   }

   public void setRect(double var1, double var3, double var5, double var7) {
      int var9 = (int)Math.floor(var1);
      int var10 = (int)Math.floor(var3);
      int var11 = (int)Math.ceil(var1 + var5);
      int var12 = (int)Math.ceil(var3 + var7);
      this.setBounds(var9, var10, var11 - var9, var12 - var10);
   }

   public void reshape(int var1, int var2, int var3, int var4) {
      this.field_0 = var1;
      this.field_1 = var2;
      this.width = var3;
      this.height = var4;
   }

   public Point getLocation() {
      return new Point(this.field_0, this.field_1);
   }

   public void setLocation(Point var1) {
      this.setLocation(var1.x, var1.y);
   }

   public void setLocation(int var1, int var2) {
      this.move(var1, var2);
   }

   public void move(int var1, int var2) {
      this.field_0 = var1;
      this.field_1 = var2;
   }

   public void translate(int var1, int var2) {
      this.field_0 += var1;
      this.field_1 += var2;
   }

   public Dimension getSize() {
      return new Dimension(this.width, this.height);
   }

   public void setSize(Dimension var1) {
      this.setSize(var1.width, var1.height);
   }

   public void setSize(int var1, int var2) {
      this.resize(var1, var2);
   }

   public void resize(int var1, int var2) {
      this.width = var1;
      this.height = var2;
   }

   public boolean contains(Point var1) {
      return this.contains(var1.x, var1.y);
   }

   public boolean contains(int var1, int var2) {
      return this.inside(var1, var2);
   }

   public boolean contains(Rectangle var1) {
      return this.contains(var1.field_0, var1.field_1, var1.width, var1.height);
   }

   public boolean contains(int var1, int var2, int var3, int var4) {
      int var5 = this.width;
      int var6 = this.height;
      if (var5 > 0 && var6 > 0 && var3 > 0 && var4 > 0) {
         int var7 = this.field_0;
         int var8 = this.field_1;
         return var1 >= var7 && var2 >= var8 && var1 + var3 <= var7 + var5 && var2 + var4 <= var8 + var6;
      } else {
         return false;
      }
   }

   public boolean inside(int var1, int var2) {
      return var1 >= this.field_0 && var1 - this.field_0 < this.width && var2 >= this.field_1 && var2 - this.field_1 < this.height;
   }

   public boolean intersects(Rectangle var1) {
      return var1.field_0 + var1.width > this.field_0 && var1.field_1 + var1.height > this.field_1 && var1.field_0 < this.field_0 + this.width && var1.field_1 < this.field_1 + this.height;
   }

   public Rectangle intersection(Rectangle var1) {
      int var2 = Math.max(this.field_0, var1.field_0);
      int var3 = Math.min(this.field_0 + this.width, var1.field_0 + var1.width);
      int var4 = Math.max(this.field_1, var1.field_1);
      int var5 = Math.min(this.field_1 + this.height, var1.field_1 + var1.height);
      return var3 - var2 >= 0 && var5 - var4 >= 0 ? new Rectangle(var2, var4, var3 - var2, var5 - var4) : new Rectangle(0, 0, 0, 0);
   }

   public Rectangle union(Rectangle var1) {
      int var2 = Math.min(this.field_0, var1.field_0);
      int var3 = Math.max(this.field_0 + this.width, var1.field_0 + var1.width);
      int var4 = Math.min(this.field_1, var1.field_1);
      int var5 = Math.max(this.field_1 + this.height, var1.field_1 + var1.height);
      return new Rectangle(var2, var4, var3 - var2, var5 - var4);
   }

   public void add(int var1, int var2) {
      int var3 = Math.min(this.field_0, var1);
      int var4 = Math.max(this.field_0 + this.width, var1);
      int var5 = Math.min(this.field_1, var2);
      int var6 = Math.max(this.field_1 + this.height, var2);
      this.field_0 = var3;
      this.field_1 = var5;
      this.width = var4 - var3;
      this.height = var6 - var5;
   }

   public void add(Point var1) {
      this.add(var1.x, var1.y);
   }

   public void add(Rectangle var1) {
      int var2 = Math.min(this.field_0, var1.field_0);
      int var3 = Math.max(this.field_0 + this.width, var1.field_0 + var1.width);
      int var4 = Math.min(this.field_1, var1.field_1);
      int var5 = Math.max(this.field_1 + this.height, var1.field_1 + var1.height);
      this.field_0 = var2;
      this.field_1 = var4;
      this.width = var3 - var2;
      this.height = var5 - var4;
   }

   public void grow(int var1, int var2) {
      this.field_0 -= var1;
      this.field_1 -= var2;
      this.width += var1 * 2;
      this.height += var2 * 2;
   }

   public boolean isEmpty() {
      return this.width <= 0 || this.height <= 0;
   }

   public int outcode(double var1, double var3) {
      int var5 = 0;
      if (this.width <= 0) {
         var5 |= 5;
      } else if (var1 < (double)this.field_0) {
         var5 |= 1;
      } else if (var1 > (double)(this.field_0 + this.width)) {
         var5 |= 4;
      }

      if (this.height <= 0) {
         var5 |= 10;
      } else if (var3 < (double)this.field_1) {
         var5 |= 2;
      } else if (var3 > (double)(this.field_1 + this.height)) {
         var5 |= 8;
      }

      return var5;
   }

   public Rectangle2D createIntersection(Rectangle2D var1) {
      if (var1 instanceof Rectangle) {
         return this.intersection((Rectangle)var1);
      } else {
         Rectangle2D.Double var2 = new Rectangle2D.Double();
         Rectangle2D.intersect(this, var1, var2);
         return var2;
      }
   }

   public Rectangle2D createUnion(Rectangle2D var1) {
      if (var1 instanceof Rectangle) {
         return this.union((Rectangle)var1);
      } else {
         Rectangle2D.Double var2 = new Rectangle2D.Double();
         Rectangle2D.union(this, var1, var2);
         return var2;
      }
   }

   public boolean equals(Object var1) {
      if (!(var1 instanceof Rectangle)) {
         return super.equals(var1);
      } else {
         Rectangle var2 = (Rectangle)var1;
         return this.field_0 == var2.field_0 && this.field_1 == var2.field_1 && this.width == var2.width && this.height == var2.height;
      }
   }

   public String toString() {
      return this.getClass().getName() + "[x=" + this.field_0 + ",y=" + this.field_1 + ",width=" + this.width + ",height=" + this.height + "]";
   }

   static {
      Toolkit.loadLibraries();
      initIDs();
   }
}
