package java.awt;

import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;
import java.awt.geom.RectangularShape;
import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;

public class TexturePaint implements Paint {
   BufferedImage bufImg;
   // $FF: renamed from: tx double
   double field_0;
   // $FF: renamed from: ty double
   double field_1;
   // $FF: renamed from: sx double
   double field_2;
   // $FF: renamed from: sy double
   double field_3;

   public TexturePaint(BufferedImage var1, Rectangle2D var2) {
      this.bufImg = var1;
      this.field_0 = ((RectangularShape)var2).getX();
      this.field_1 = ((RectangularShape)var2).getY();
      this.field_2 = ((RectangularShape)var2).getWidth() / (double)this.bufImg.getWidth();
      this.field_3 = ((RectangularShape)var2).getHeight() / (double)this.bufImg.getHeight();
   }

   public BufferedImage getImage() {
      return this.bufImg;
   }

   public Rectangle2D getAnchorRect() {
      return new Rectangle2D.Double(this.field_0, this.field_1, this.field_2 * (double)this.bufImg.getWidth(), this.field_3 * (double)this.bufImg.getHeight());
   }

   public PaintContext createContext(ColorModel var1, Rectangle var2, Rectangle2D var3, AffineTransform var4, RenderingHints var5) {
      if (var4 == null) {
         var4 = new AffineTransform();
      } else {
         var4 = (AffineTransform)var4.clone();
      }

      var4.translate(this.field_0, this.field_1);
      var4.scale(this.field_2, this.field_3);
      return TexturePaintContext.getContext(this.bufImg, var4, var5, var2);
   }

   public int getTransparency() {
      return this.bufImg.getColorModel().getTransparency();
   }
}
