package java.awt;

import java.awt.geom.AffineTransform;
import java.awt.image.ColorModel;
import java.awt.image.DirectColorModel;
import java.awt.image.IndexColorModel;
import java.awt.image.Raster;
import java.awt.image.WritableRaster;
import sun.awt.image.ByteInterleavedRaster;
import sun.awt.image.IntegerInterleavedRaster;

class TexturePaintContext$ByteFilter extends TexturePaintContext {
   ByteInterleavedRaster srcRas;
   int[] inPalette = new int[256];
   byte[] inData;
   int inOff;
   int inSpan;
   int[] outData;
   int outOff;
   int outSpan;
   public static ColorModel xrgbmodel = new DirectColorModel(24, 16711680, 65280, 255);
   public static ColorModel argbmodel = ColorModel.getRGBdefault();

   public TexturePaintContext$ByteFilter(ByteInterleavedRaster var1, ColorModel var2, AffineTransform var3, int var4) {
      super(var2.getTransparency() == 1 ? xrgbmodel : argbmodel, var3, ((Raster)var1).getWidth(), ((Raster)var1).getHeight(), var4);
      ((IndexColorModel)var2).getRGBs(this.inPalette);
      this.srcRas = var1;
      this.inData = var1.getDataStorage();
      this.inSpan = var1.getScanlineStride();
      this.inOff = var1.getDataOffset(0);
   }

   public WritableRaster makeRaster(int var1, int var2) {
      WritableRaster var3 = super.colorModel.createCompatibleWritableRaster(var1, var2);
      IntegerInterleavedRaster var4 = (IntegerInterleavedRaster)var3;
      this.outData = var4.getDataStorage();
      this.outSpan = var4.getScanlineStride();
      this.outOff = var4.getDataOffset(0);
      return var3;
   }

   public void setRaster(int var1, int var2, int var3, int var4, int var5, int var6, int var7, int var8, int var9, int var10, int var11, int var12, int var13, int var14, int var15, int var16) {
      byte[] var17 = this.inData;
      int[] var18 = this.outData;
      int var19 = this.outOff;
      int var20 = this.inSpan;
      int var21 = this.inOff;
      int var22 = this.outSpan;
      int var23 = var1;
      int var24 = var2;
      int var25 = var3;
      int var26 = var4;
      int[] var27 = new int[4];

      for(int var28 = 0; var28 < var6; ++var28) {
         var1 = var23;
         var2 = var24;
         var3 = var25;
         var4 = var26;

         for(int var29 = 0; var29 < var5; ++var29) {
            int var30;
            if ((var30 = var1 + 1) >= var7) {
               var30 = 0;
            }

            int var31;
            if ((var31 = var2 + 1) >= var8) {
               var31 = 0;
            }

            var27[0] = this.inPalette[255 & var17[var21 + var1 + var20 * var2]];
            var27[1] = this.inPalette[255 & var17[var21 + var30 + var20 * var2]];
            var27[2] = this.inPalette[255 & var17[var21 + var1 + var20 * var31]];
            var27[3] = this.inPalette[255 & var17[var21 + var30 + var20 * var31]];
            var18[var19 + var29] = TexturePaintContext.blend(var27, var3, var4);
            if ((var3 += var10) < 0) {
               var3 &= Integer.MAX_VALUE;
               ++var1;
            }

            if ((var1 += var9) >= var7) {
               var1 -= var7;
            }

            if ((var4 += var12) < 0) {
               var4 &= Integer.MAX_VALUE;
               ++var2;
            }

            if ((var2 += var11) >= var8) {
               var2 -= var8;
            }
         }

         if ((var25 += var14) < 0) {
            var25 &= Integer.MAX_VALUE;
            ++var23;
         }

         if ((var23 += var13) >= var7) {
            var23 -= var7;
         }

         if ((var26 += var16) < 0) {
            var26 &= Integer.MAX_VALUE;
            ++var24;
         }

         if ((var24 += var15) >= var8) {
            var24 -= var8;
         }

         var19 += var22;
      }

   }
}
