package java.awt.font;

import java.awt.Font;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

public abstract class GlyphVector implements Cloneable {
   public abstract Font getFont();

   public abstract FontRenderContext getFontRenderContext();

   public abstract void performDefaultLayout();

   public abstract int getNumGlyphs();

   public abstract int getGlyphCode(int var1);

   public abstract int[] getGlyphCodes(int var1, int var2, int[] var3);

   public abstract Rectangle2D getLogicalBounds();

   public abstract Rectangle2D getVisualBounds();

   public abstract Shape getOutline();

   public abstract Shape getOutline(float var1, float var2);

   public abstract Shape getGlyphOutline(int var1);

   public abstract Point2D getGlyphPosition(int var1);

   public abstract void setGlyphPosition(int var1, Point2D var2);

   public abstract AffineTransform getGlyphTransform(int var1);

   public abstract void setGlyphTransform(int var1, AffineTransform var2);

   public abstract float[] getGlyphPositions(int var1, int var2, float[] var3);

   public abstract Shape getGlyphLogicalBounds(int var1);

   public abstract Shape getGlyphVisualBounds(int var1);

   public abstract GlyphMetrics getGlyphMetrics(int var1);

   public abstract GlyphJustificationInfo getGlyphJustificationInfo(int var1);

   public abstract boolean equals(GlyphVector var1);
}
