package java.awt.font;

import java.awt.Font;
import java.text.AttributedCharacterIterator;
import java.util.Map;
import sun.java2d.SunGraphicsEnvironment;

class TextLine$ACIFontSource extends TextLine.FontSource {
   private AttributedCharacterIterator fIter;
   private int fIterStart;

   public TextLine$ACIFontSource(AttributedCharacterIterator var1) {
      this.fIter = var1;
      this.fIterStart = var1.getBeginIndex();
   }

   int getLength() {
      return this.fIter.getEndIndex() - this.fIterStart;
   }

   int getRunLimit(int var1) {
      this.fIter.setIndex(var1 + this.fIterStart);
      return this.fIter.getRunLimit() - this.fIterStart;
   }

   GraphicAttribute graphicAt(int var1) {
      this.fIter.setIndex(var1 + this.fIterStart);
      return (GraphicAttribute)this.fIter.getAttribute(TextAttribute.CHAR_REPLACEMENT);
   }

   Font fontAt(int var1) {
      this.fIter.setIndex(var1 + this.fIterStart);
      return (Font)this.fIter.getAttribute(TextAttribute.FONT);
   }

   Font getBestFontAt(int var1) {
      int var2 = var1 + this.fIterStart;
      this.fIter.setIndex(var2);
      return SunGraphicsEnvironment.getBestFontFor(this.fIter, var2, this.fIter.getRunLimit());
   }

   Map attributesAt(int var1) {
      this.fIter.setIndex(var1 + this.fIterStart);
      return this.fIter.getAttributes();
   }
}
