package java.awt.geom;

public abstract class Ellipse2D extends RectangularShape {
   protected Ellipse2D() {
   }

   public boolean contains(double var1, double var3) {
      double var5 = ((RectangularShape)this).getWidth();
      if (var5 <= (double)0.0F) {
         return false;
      } else {
         double var7 = (var1 - ((RectangularShape)this).getX()) / var5 - (double)0.5F;
         double var9 = ((RectangularShape)this).getHeight();
         if (var9 <= (double)0.0F) {
            return false;
         } else {
            double var11 = (var3 - ((RectangularShape)this).getY()) / var9 - (double)0.5F;
            return var7 * var7 + var11 * var11 < (double)0.25F;
         }
      }
   }

   public boolean intersects(double var1, double var3, double var5, double var7) {
      if (!(var5 <= (double)0.0F) && !(var7 <= (double)0.0F)) {
         double var9 = ((RectangularShape)this).getWidth();
         if (var9 <= (double)0.0F) {
            return false;
         } else {
            double var11 = (var1 - ((RectangularShape)this).getX()) / var9 - (double)0.5F;
            double var13 = var11 + var5 / var9;
            double var15 = ((RectangularShape)this).getHeight();
            if (var15 <= (double)0.0F) {
               return false;
            } else {
               double var17 = (var3 - ((RectangularShape)this).getY()) / var15 - (double)0.5F;
               double var19 = var17 + var7 / var15;
               double var21;
               if (var11 > (double)0.0F) {
                  var21 = var11;
               } else if (var13 < (double)0.0F) {
                  var21 = var13;
               } else {
                  var21 = (double)0.0F;
               }

               double var23;
               if (var17 > (double)0.0F) {
                  var23 = var17;
               } else if (var19 < (double)0.0F) {
                  var23 = var19;
               } else {
                  var23 = (double)0.0F;
               }

               return var21 * var21 + var23 * var23 < (double)0.25F;
            }
         }
      } else {
         return false;
      }
   }

   public boolean contains(double var1, double var3, double var5, double var7) {
      return this.contains(var1, var3) && this.contains(var1 + var5, var3) && this.contains(var1, var3 + var7) && this.contains(var1 + var5, var3 + var7);
   }

   public PathIterator getPathIterator(AffineTransform var1) {
      return new EllipseIterator(this, var1);
   }
}
