package java.awt.geom;

public abstract class Rectangle2D extends RectangularShape {
   public static final int OUT_LEFT = 1;
   public static final int OUT_TOP = 2;
   public static final int OUT_RIGHT = 4;
   public static final int OUT_BOTTOM = 8;

   protected Rectangle2D() {
   }

   public abstract void setRect(double var1, double var3, double var5, double var7);

   public void setRect(Rectangle2D var1) {
      this.setRect(((RectangularShape)var1).getX(), ((RectangularShape)var1).getY(), ((RectangularShape)var1).getWidth(), ((RectangularShape)var1).getHeight());
   }

   public boolean intersectsLine(double var1, double var3, double var5, double var7) {
      int var9 = this.outcode(var1, var3);

      for(int var10 = this.outcode(var5, var7); (var9 & var10) == 0; var9 = this.outcode(var1, var3)) {
         if (var9 == 0) {
            if (var10 == 0) {
               return true;
            }

            double var11 = var1;
            var1 = var5;
            var5 = var11;
            var11 = var3;
            var3 = var7;
            var7 = var11;
            int var13 = var9;
            var9 = var10;
            var10 = var13;
         }

         if ((var9 & 5) != 0) {
            double var15 = ((RectangularShape)this).getX();
            if ((var9 & 4) != 0) {
               var15 += ((RectangularShape)this).getWidth();
            }

            var3 += (var15 - var1) * (var7 - var3) / (var5 - var1);
            var1 = var15;
         } else if ((var9 & 10) != 0) {
            double var16 = ((RectangularShape)this).getY();
            if ((var9 & 8) != 0) {
               var16 += ((RectangularShape)this).getHeight();
            }

            var1 += (var16 - var3) * (var5 - var1) / (var7 - var3);
            var3 = var16;
         }
      }

      return false;
   }

   public boolean intersectsLine(Line2D var1) {
      return this.intersectsLine(var1.getX1(), var1.getY1(), var1.getX2(), var1.getY2());
   }

   public abstract int outcode(double var1, double var3);

   public int outcode(Point2D var1) {
      return this.outcode(var1.getX(), var1.getY());
   }

   public void setFrame(double var1, double var3, double var5, double var7) {
      this.setRect(var1, var3, var5, var7);
   }

   public Rectangle2D getBounds2D() {
      return (Rectangle2D)((RectangularShape)this).clone();
   }

   public boolean contains(double var1, double var3) {
      double var5 = ((RectangularShape)this).getX();
      double var7 = ((RectangularShape)this).getY();
      return var1 >= var5 && var3 >= var7 && var1 < var5 + ((RectangularShape)this).getWidth() && var3 < var7 + ((RectangularShape)this).getHeight();
   }

   public boolean intersects(double var1, double var3, double var5, double var7) {
      if (!((RectangularShape)this).isEmpty() && !(var5 <= (double)0.0F) && !(var7 <= (double)0.0F)) {
         double var9 = ((RectangularShape)this).getX();
         double var11 = ((RectangularShape)this).getY();
         return var1 + var5 > var9 && var3 + var7 > var11 && var1 < var9 + ((RectangularShape)this).getWidth() && var3 < var11 + ((RectangularShape)this).getHeight();
      } else {
         return false;
      }
   }

   public boolean contains(double var1, double var3, double var5, double var7) {
      if (!((RectangularShape)this).isEmpty() && !(var5 <= (double)0.0F) && !(var7 <= (double)0.0F)) {
         double var9 = ((RectangularShape)this).getX();
         double var11 = ((RectangularShape)this).getY();
         return var1 >= var9 && var3 >= var11 && var1 + var5 <= var9 + ((RectangularShape)this).getWidth() && var3 + var7 <= var11 + ((RectangularShape)this).getHeight();
      } else {
         return false;
      }
   }

   public abstract Rectangle2D createIntersection(Rectangle2D var1);

   public static void intersect(Rectangle2D var0, Rectangle2D var1, Rectangle2D var2) {
      double var3 = Math.max(((RectangularShape)var0).getMinX(), ((RectangularShape)var1).getMinX());
      double var5 = Math.max(((RectangularShape)var0).getMinY(), ((RectangularShape)var1).getMinY());
      double var7 = Math.min(((RectangularShape)var0).getMaxX(), ((RectangularShape)var1).getMaxX());
      double var9 = Math.min(((RectangularShape)var0).getMaxY(), ((RectangularShape)var1).getMaxY());
      ((RectangularShape)var2).setFrameFromDiagonal(var3, var5, var7, var9);
   }

   public abstract Rectangle2D createUnion(Rectangle2D var1);

   public static void union(Rectangle2D var0, Rectangle2D var1, Rectangle2D var2) {
      double var3 = Math.min(((RectangularShape)var0).getMinX(), ((RectangularShape)var1).getMinX());
      double var5 = Math.min(((RectangularShape)var0).getMinY(), ((RectangularShape)var1).getMinY());
      double var7 = Math.max(((RectangularShape)var0).getMaxX(), ((RectangularShape)var1).getMaxX());
      double var9 = Math.max(((RectangularShape)var0).getMaxY(), ((RectangularShape)var1).getMaxY());
      ((RectangularShape)var2).setFrameFromDiagonal(var3, var5, var7, var9);
   }

   public void add(double var1, double var3) {
      double var5 = Math.min(((RectangularShape)this).getMinX(), var1);
      double var7 = Math.max(((RectangularShape)this).getMaxX(), var1);
      double var9 = Math.min(((RectangularShape)this).getMinY(), var3);
      double var11 = Math.max(((RectangularShape)this).getMaxY(), var3);
      this.setRect(var5, var9, var7 - var5, var11 - var9);
   }

   public void add(Point2D var1) {
      this.add(var1.getX(), var1.getY());
   }

   public void add(Rectangle2D var1) {
      double var2 = Math.min(((RectangularShape)this).getMinX(), ((RectangularShape)var1).getMinX());
      double var4 = Math.max(((RectangularShape)this).getMaxX(), ((RectangularShape)var1).getMaxX());
      double var6 = Math.min(((RectangularShape)this).getMinY(), ((RectangularShape)var1).getMinY());
      double var8 = Math.max(((RectangularShape)this).getMaxY(), ((RectangularShape)var1).getMaxY());
      this.setRect(var2, var6, var4 - var2, var8 - var6);
   }

   public PathIterator getPathIterator(AffineTransform var1) {
      return new RectIterator(this, var1);
   }

   public PathIterator getPathIterator(AffineTransform var1, double var2) {
      return new RectIterator(this, var1);
   }

   public int hashCode() {
      long var1 = java.lang.Double.doubleToLongBits(((RectangularShape)this).getX());
      var1 += java.lang.Double.doubleToLongBits(((RectangularShape)this).getY()) * 37L;
      var1 += java.lang.Double.doubleToLongBits(((RectangularShape)this).getWidth()) * 43L;
      var1 += java.lang.Double.doubleToLongBits(((RectangularShape)this).getHeight()) * 47L;
      return (int)var1 ^ (int)(var1 >> 32);
   }

   public boolean equals(Object var1) {
      if (var1 == this) {
         return true;
      } else if (!(var1 instanceof Rectangle2D)) {
         return false;
      } else {
         Rectangle2D var2 = (Rectangle2D)var1;
         return ((RectangularShape)this).getX() == ((RectangularShape)var2).getX() && ((RectangularShape)this).getY() == ((RectangularShape)var2).getY() && ((RectangularShape)this).getWidth() == ((RectangularShape)var2).getWidth() && ((RectangularShape)this).getHeight() == ((RectangularShape)var2).getHeight();
      }
   }
}
