package java.awt.image;

public final class DataBufferInt extends DataBuffer {
   int[] data;
   int[][] bankdata;

   public DataBufferInt(int var1) {
      super(3, var1);
      this.data = new int[var1];
      this.bankdata = new int[1][];
      this.bankdata[0] = this.data;
   }

   public DataBufferInt(int var1, int var2) {
      super(3, var1, var2);
      this.bankdata = new int[var2][];

      for(int var3 = 0; var3 < var2; ++var3) {
         this.bankdata[var3] = new int[var1];
      }

      this.data = this.bankdata[0];
   }

   public DataBufferInt(int[] var1, int var2) {
      super(3, var2);
      this.data = var1;
      this.bankdata = new int[1][];
      this.bankdata[0] = this.data;
   }

   public DataBufferInt(int[] var1, int var2, int var3) {
      super(3, var2, 1, var3);
      this.data = var1;
      this.bankdata = new int[1][];
      this.bankdata[0] = this.data;
   }

   public DataBufferInt(int[][] var1, int var2) {
      super(3, var2, var1.length);
      this.bankdata = var1;
      this.data = this.bankdata[0];
   }

   public DataBufferInt(int[][] var1, int var2, int[] var3) {
      super(3, var2, var1.length, var3);
      this.bankdata = var1;
      this.data = this.bankdata[0];
   }

   public int[] getData() {
      return this.data;
   }

   public int[] getData(int var1) {
      return this.bankdata[var1];
   }

   public int[][] getBankData() {
      return this.bankdata;
   }

   public int getElem(int var1) {
      return this.data[var1 + super.offset];
   }

   public int getElem(int var1, int var2) {
      return this.bankdata[var1][var2 + super.offsets[var1]];
   }

   public void setElem(int var1, int var2) {
      this.data[var1 + super.offset] = var2;
   }

   public void setElem(int var1, int var2, int var3) {
      this.bankdata[var1][var2 + super.offsets[var1]] = var3;
   }
}
