package java.awt.image;

public final class DataBufferShort extends DataBuffer {
   short[] data;
   short[][] bankdata;

   public DataBufferShort(int var1) {
      super(2, var1);
      this.data = new short[var1];
      this.bankdata = new short[1][];
      this.bankdata[0] = this.data;
   }

   public DataBufferShort(int var1, int var2) {
      super(2, var1, var2);
      this.bankdata = new short[var2][];

      for(int var3 = 0; var3 < var2; ++var3) {
         this.bankdata[var3] = new short[var1];
      }

      this.data = this.bankdata[0];
   }

   public DataBufferShort(short[] var1, int var2) {
      super(2, var2);
      this.data = var1;
      this.bankdata = new short[1][];
      this.bankdata[0] = this.data;
   }

   public DataBufferShort(short[] var1, int var2, int var3) {
      super(2, var2, 1, var3);
      this.data = var1;
      this.bankdata = new short[1][];
      this.bankdata[0] = this.data;
   }

   public DataBufferShort(short[][] var1, int var2) {
      super(2, var2, var1.length);
      this.bankdata = var1;
      this.data = this.bankdata[0];
   }

   public DataBufferShort(short[][] var1, int var2, int[] var3) {
      super(2, var2, var1.length, var3);
      this.bankdata = var1;
      this.data = this.bankdata[0];
   }

   public short[] getData() {
      return this.data;
   }

   public short[] getData(int var1) {
      return this.bankdata[var1];
   }

   public short[][] getBankData() {
      return this.bankdata;
   }

   public int getElem(int var1) {
      return this.data[var1 + super.offset];
   }

   public int getElem(int var1, int var2) {
      return this.bankdata[var1][var2 + super.offsets[var1]];
   }

   public void setElem(int var1, int var2) {
      this.data[var1 + super.offset] = (short)var2;
   }

   public void setElem(int var1, int var2, int var3) {
      this.bankdata[var1][var2 + super.offsets[var1]] = (short)var3;
   }
}
