package java.awt.image;

public class PixelInterleavedSampleModel extends ComponentSampleModel {
   public PixelInterleavedSampleModel(int var1, int var2, int var3, int var4, int var5, int[] var6) {
      super(var1, var2, var3, var4, var5, var6);
      int var7 = var6[0];
      int var8 = var6[0];

      for(int var9 = 1; var9 < var6.length; ++var9) {
         var7 = Math.min(var7, var6[var9]);
         var8 = Math.max(var8, var6[var9]);
      }

      var8 -= var7;
      if (var8 > var5) {
         throw new IllegalArgumentException("Offsets between bands must be less than the scanline  stride");
      } else if (var4 * var2 > var5) {
         throw new IllegalArgumentException("Pixel stride times width must be less than or equal to the scanline stride");
      } else if (var4 < var8) {
         throw new IllegalArgumentException("Pixel stride must be greater than or equal to the offsets between bands");
      }
   }

   public SampleModel createCompatibleSampleModel(int var1, int var2) {
      int var3 = super.bandOffsets[0];
      int var4 = super.bandOffsets.length;

      for(int var5 = 1; var5 < var4; ++var5) {
         if (super.bandOffsets[var5] < var3) {
            var3 = super.bandOffsets[var5];
         }
      }

      int[] var6;
      if (var3 > 0) {
         var6 = new int[var4];

         for(int var7 = 0; var7 < var4; ++var7) {
            var6[var7] = super.bandOffsets[var7] - var3;
         }
      } else {
         var6 = super.bandOffsets;
      }

      return new PixelInterleavedSampleModel(super.dataType, var1, var2, super.pixelStride, super.pixelStride * var1, var6);
   }

   public SampleModel createSubsetSampleModel(int[] var1) {
      int[] var2 = new int[var1.length];

      for(int var3 = 0; var3 < var1.length; ++var3) {
         var2[var3] = super.bandOffsets[var1[var3]];
      }

      return new PixelInterleavedSampleModel(super.dataType, super.width, super.height, super.pixelStride, super.scanlineStride, var2);
   }
}
