package java.awt.print;

import java.awt.geom.Rectangle2D;

public class Paper implements Cloneable {
   private static final int INCH = 72;
   private static final double LETTER_WIDTH = (double)612.0F;
   private static final double LETTER_HEIGHT = (double)792.0F;
   private double mHeight = (double)792.0F;
   private double mWidth = (double)612.0F;
   private Rectangle2D mImageableArea;

   public Paper() {
      this.mImageableArea = new Rectangle2D.Double((double)72.0F, (double)72.0F, this.mWidth - (double)144.0F, this.mHeight - (double)144.0F);
   }

   public Object clone() {
      Paper var1;
      try {
         var1 = (Paper)super.clone();
      } catch (CloneNotSupportedException var3) {
         ((Throwable)var3).printStackTrace();
         var1 = null;
      }

      return var1;
   }

   public double getHeight() {
      return this.mHeight;
   }

   public void setSize(double var1, double var3) {
      this.mWidth = var1;
      this.mHeight = var3;
   }

   public double getWidth() {
      return this.mWidth;
   }

   public void setImageableArea(double var1, double var3, double var5, double var7) {
      this.mImageableArea = new Rectangle2D.Double(var1, var3, var5, var7);
   }

   public double getImageableX() {
      return this.mImageableArea.getX();
   }

   public double getImageableY() {
      return this.mImageableArea.getY();
   }

   public double getImageableWidth() {
      return this.mImageableArea.getWidth();
   }

   public double getImageableHeight() {
      return this.mImageableArea.getHeight();
   }
}
