package java.awt.print;

import java.security.AccessController;

public abstract class PrinterJob {
   public static PrinterJob getPrinterJob() {
      SecurityManager var0 = System.getSecurityManager();
      if (var0 != null) {
         var0.checkPrintJobAccess();
      }

      return (PrinterJob)AccessController.doPrivileged(new 1());
   }

   public abstract void setPrintable(Printable var1);

   public abstract void setPrintable(Printable var1, PageFormat var2);

   public abstract void setPageable(Pageable var1) throws NullPointerException;

   public abstract boolean printDialog();

   public abstract PageFormat pageDialog(PageFormat var1);

   public abstract PageFormat defaultPage(PageFormat var1);

   public PageFormat defaultPage() {
      return this.defaultPage(new PageFormat());
   }

   public abstract PageFormat validatePage(PageFormat var1);

   public abstract void print() throws PrinterException;

   public abstract void setCopies(int var1);

   public abstract int getCopies();

   public abstract String getUserName();

   public abstract void setJobName(String var1);

   public abstract String getJobName();

   public abstract void cancel();

   public abstract boolean isCancelled();
}
