package java.awt;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.peer.CheckboxMenuItemPeer;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.EventListener;
import javax.accessibility.Accessible;
import javax.accessibility.AccessibleContext;

public class CheckboxMenuItem extends MenuItem implements ItemSelectable, Accessible {
   boolean state;
   transient ItemListener itemListener;
   private static final String base = "chkmenuitem";
   private static int nameCounter;
   private static final long serialVersionUID = 6190621106981774043L;
   private int checkboxMenuItemSerializedDataVersion;
   // $FF: synthetic field
   static Class class$java$awt$event$ItemListener;

   public CheckboxMenuItem() {
      this("", false);
   }

   public CheckboxMenuItem(String var1) {
      this(var1, false);
   }

   public CheckboxMenuItem(String var1, boolean var2) {
      super(var1);
      this.state = false;
      this.checkboxMenuItemSerializedDataVersion = 1;
      this.state = var2;
   }

   String constructComponentName() {
      Class var1 = this.getClass();
      synchronized(var1) {
         String var2 = "chkmenuitem" + nameCounter++;
         return var2;
      }
   }

   public void addNotify() {
      Object var1 = ((MenuComponent)this).getTreeLock();
      synchronized(var1) {
         if (super.peer == null) {
            super.peer = Toolkit.getDefaultToolkit().createCheckboxMenuItem(this);
         }

         super.addNotify();
      }
   }

   public boolean getState() {
      return this.state;
   }

   public synchronized void setState(boolean var1) {
      this.state = var1;
      CheckboxMenuItemPeer var2 = (CheckboxMenuItemPeer)super.peer;
      if (var2 != null) {
         var2.setState(var1);
      }

   }

   public synchronized Object[] getSelectedObjects() {
      if (this.state) {
         Object[] var1 = new Object[]{super.label};
         return var1;
      } else {
         return null;
      }
   }

   public synchronized void addItemListener(ItemListener var1) {
      if (var1 != null) {
         this.itemListener = AWTEventMulticaster.add(this.itemListener, var1);
         super.newEventsOnly = true;
      }
   }

   public synchronized void removeItemListener(ItemListener var1) {
      if (var1 != null) {
         this.itemListener = AWTEventMulticaster.remove(this.itemListener, var1);
      }
   }

   public EventListener[] getListeners(Class var1) {
      Object var2 = null;
      if (var1 == (class$java$awt$event$ItemListener == null ? (class$java$awt$event$ItemListener = class$("java.awt.event.ItemListener")) : class$java$awt$event$ItemListener)) {
         ItemListener var3 = this.itemListener;
         return AWTEventMulticaster.getListeners(var3, var1);
      } else {
         return super.getListeners(var1);
      }
   }

   boolean eventEnabled(AWTEvent var1) {
      if (var1.id == 701) {
         return (super.eventMask & 512L) != 0L || this.itemListener != null;
      } else {
         return super.eventEnabled(var1);
      }
   }

   protected void processEvent(AWTEvent var1) {
      if (var1 instanceof ItemEvent) {
         this.processItemEvent((ItemEvent)var1);
      } else {
         super.processEvent(var1);
      }
   }

   protected void processItemEvent(ItemEvent var1) {
      if (this.itemListener != null) {
         this.itemListener.itemStateChanged(var1);
      }

   }

   void doMenuEvent() {
      this.setState(!this.state);
      Toolkit.getEventQueue().postEvent(new ItemEvent(this, 701, ((MenuItem)this).getLabel(), this.state ? 1 : 2));
   }

   public String paramString() {
      return super.paramString() + ",state=" + this.state;
   }

   private void writeObject(ObjectOutputStream var1) throws IOException {
      var1.defaultWriteObject();
      AWTEventMulticaster.save(var1, "itemL", this.itemListener);
      var1.writeObject((Object)null);
   }

   private void readObject(ObjectInputStream var1) throws ClassNotFoundException, IOException {
      var1.defaultReadObject();

      Object var2;
      while(null != (var2 = var1.readObject())) {
         String var3 = ((String)var2).intern();
         if ("itemL" == var3) {
            this.addItemListener((ItemListener)var1.readObject());
         } else {
            var1.readObject();
         }
      }

   }

   private static native void initIDs();

   public AccessibleContext getAccessibleContext() {
      if (super.accessibleContext == null) {
         super.accessibleContext = new AccessibleAWTCheckboxMenuItem(this);
      }

      return super.accessibleContext;
   }

   // $FF: synthetic method
   static Class class$(String var0) {
      try {
         return Class.forName(var0);
      } catch (ClassNotFoundException var2) {
         throw new NoClassDefFoundError(((Throwable)var2).getMessage());
      }
   }

   static {
      Toolkit.loadLibraries();
      initIDs();
      nameCounter = 0;
   }
}
