package java.awt;

import java.awt.event.ComponentListener;
import java.awt.event.FocusListener;
import java.beans.PropertyChangeListener;
import java.io.Serializable;
import java.util.Locale;
import javax.accessibility.Accessible;
import javax.accessibility.AccessibleComponent;
import javax.accessibility.AccessibleContext;
import javax.accessibility.AccessibleRole;
import javax.accessibility.AccessibleState;
import javax.accessibility.AccessibleStateSet;

public abstract class Component$AccessibleAWTComponent extends AccessibleContext implements Serializable, AccessibleComponent {
   protected ComponentListener accessibleAWTComponentHandler;
   protected FocusListener accessibleAWTFocusHandler;
   // $FF: synthetic field
   private final Component this$0;

   protected Component$AccessibleAWTComponent(Component var1) {
      this.this$0 = var1;
      this.accessibleAWTComponentHandler = null;
      this.accessibleAWTFocusHandler = null;
   }

   public void addPropertyChangeListener(PropertyChangeListener var1) {
      if (this.accessibleAWTComponentHandler == null) {
         this.accessibleAWTComponentHandler = new Component.AccessibleAWTComponent.AccessibleAWTComponentHandler(this);
         this.this$0.addComponentListener(this.accessibleAWTComponentHandler);
      }

      if (this.accessibleAWTFocusHandler == null) {
         this.accessibleAWTFocusHandler = new Component.AccessibleAWTComponent.AccessibleAWTFocusHandler(this);
         this.this$0.addFocusListener(this.accessibleAWTFocusHandler);
      }

      super.addPropertyChangeListener(var1);
   }

   public void removePropertyChangeListener(PropertyChangeListener var1) {
      if (this.accessibleAWTComponentHandler != null) {
         this.this$0.removeComponentListener(this.accessibleAWTComponentHandler);
         this.accessibleAWTComponentHandler = null;
      }

      if (this.accessibleAWTFocusHandler != null) {
         this.this$0.removeFocusListener(this.accessibleAWTFocusHandler);
         this.accessibleAWTFocusHandler = null;
      }

      super.removePropertyChangeListener(var1);
   }

   public String getAccessibleName() {
      return super.accessibleName;
   }

   public String getAccessibleDescription() {
      return super.accessibleDescription;
   }

   public AccessibleRole getAccessibleRole() {
      return AccessibleRole.AWT_COMPONENT;
   }

   public AccessibleStateSet getAccessibleStateSet() {
      return this.this$0.getAccessibleStateSet();
   }

   public Accessible getAccessibleParent() {
      if (super.accessibleParent != null) {
         return super.accessibleParent;
      } else {
         Container var1 = this.this$0.getParent();
         return var1 instanceof Accessible ? (Accessible)var1 : null;
      }
   }

   public int getAccessibleIndexInParent() {
      return this.this$0.getAccessibleIndexInParent();
   }

   public int getAccessibleChildrenCount() {
      return 0;
   }

   public Accessible getAccessibleChild(int var1) {
      return null;
   }

   public Locale getLocale() {
      return this.this$0.getLocale();
   }

   public AccessibleComponent getAccessibleComponent() {
      return this;
   }

   public Color getBackground() {
      return this.this$0.getBackground();
   }

   public void setBackground(Color var1) {
      this.this$0.setBackground(var1);
   }

   public Color getForeground() {
      return this.this$0.getForeground();
   }

   public void setForeground(Color var1) {
      this.this$0.setForeground(var1);
   }

   public Cursor getCursor() {
      return this.this$0.getCursor();
   }

   public void setCursor(Cursor var1) {
      this.this$0.setCursor(var1);
   }

   public Font getFont() {
      return this.this$0.getFont();
   }

   public void setFont(Font var1) {
      this.this$0.setFont(var1);
   }

   public FontMetrics getFontMetrics(Font var1) {
      return var1 == null ? null : this.this$0.getFontMetrics(var1);
   }

   public boolean isEnabled() {
      return this.this$0.isEnabled();
   }

   public void setEnabled(boolean var1) {
      boolean var2 = this.this$0.isEnabled();
      this.this$0.setEnabled(var1);
      if (var1 != var2 && this.this$0.accessibleContext != null) {
         if (var1) {
            this.this$0.accessibleContext.firePropertyChange("AccessibleState", (Object)null, AccessibleState.ENABLED);
         } else {
            this.this$0.accessibleContext.firePropertyChange("AccessibleState", AccessibleState.ENABLED, (Object)null);
         }
      }

   }

   public boolean isVisible() {
      return this.this$0.isVisible();
   }

   public void setVisible(boolean var1) {
      boolean var2 = this.this$0.isVisible();
      this.this$0.setVisible(var1);
      if (var1 != var2 && this.this$0.accessibleContext != null) {
         if (var1) {
            this.this$0.accessibleContext.firePropertyChange("AccessibleState", (Object)null, AccessibleState.VISIBLE);
         } else {
            this.this$0.accessibleContext.firePropertyChange("AccessibleState", AccessibleState.VISIBLE, (Object)null);
         }
      }

   }

   public boolean isShowing() {
      return this.this$0.isShowing();
   }

   public boolean contains(Point var1) {
      return this.this$0.contains(var1);
   }

   public Point getLocationOnScreen() {
      Object var1 = this.this$0.getTreeLock();
      synchronized(var1) {
         if (this.this$0.isShowing()) {
            Point var5 = this.this$0.getLocationOnScreen();
            return var5;
         } else {
            Object var2 = null;
            return (Point)var2;
         }
      }
   }

   public Point getLocation() {
      return this.this$0.getLocation();
   }

   public void setLocation(Point var1) {
      this.this$0.setLocation(var1);
   }

   public Rectangle getBounds() {
      return this.this$0.getBounds();
   }

   public void setBounds(Rectangle var1) {
      this.this$0.setBounds(var1);
   }

   public Dimension getSize() {
      return this.this$0.getSize();
   }

   public void setSize(Dimension var1) {
      this.this$0.setSize(var1);
   }

   public Accessible getAccessibleAt(Point var1) {
      return null;
   }

   public boolean isFocusTraversable() {
      return this.this$0.isFocusTraversable();
   }

   public void requestFocus() {
      this.this$0.requestFocus();
   }

   public void addFocusListener(FocusListener var1) {
      this.this$0.addFocusListener(var1);
   }

   public void removeFocusListener(FocusListener var1) {
      this.this$0.removeFocusListener(var1);
   }

   // $FF: synthetic method
   static Component access$000(Component$AccessibleAWTComponent var0) {
      return var0.this$0;
   }
}
