package java.awt.event;

import java.awt.Component;
import java.awt.Point;

public class MouseEvent extends InputEvent {
   public static final int MOUSE_FIRST = 500;
   public static final int MOUSE_LAST = 506;
   public static final int MOUSE_CLICKED = 500;
   public static final int MOUSE_PRESSED = 501;
   public static final int MOUSE_RELEASED = 502;
   public static final int MOUSE_MOVED = 503;
   public static final int MOUSE_ENTERED = 504;
   public static final int MOUSE_EXITED = 505;
   public static final int MOUSE_DRAGGED = 506;
   // $FF: renamed from: x int
   int field_0;
   // $FF: renamed from: y int
   int field_1;
   int clickCount;
   boolean popupTrigger = false;
   private static final long serialVersionUID = -991214153494842848L;

   private static native void initIDs();

   public MouseEvent(Component var1, int var2, long var3, int var5, int var6, int var7, int var8, boolean var9) {
      super(var1, var2, var3, var5);
      this.field_0 = var6;
      this.field_1 = var7;
      this.clickCount = var8;
      this.popupTrigger = var9;
   }

   public int getX() {
      return this.field_0;
   }

   public int getY() {
      return this.field_1;
   }

   public Point getPoint() {
      int var1;
      int var2;
      synchronized(this) {
         var1 = this.field_0;
         var2 = this.field_1;
      }

      return new Point(var1, var2);
   }

   public synchronized void translatePoint(int var1, int var2) {
      this.field_0 += var1;
      this.field_1 += var2;
   }

   public int getClickCount() {
      return this.clickCount;
   }

   public boolean isPopupTrigger() {
      return this.popupTrigger;
   }

   public String paramString() {
      String var1;
      switch (super.id) {
         case 500:
            var1 = "MOUSE_CLICKED";
            break;
         case 501:
            var1 = "MOUSE_PRESSED";
            break;
         case 502:
            var1 = "MOUSE_RELEASED";
            break;
         case 503:
            var1 = "MOUSE_MOVED";
            break;
         case 504:
            var1 = "MOUSE_ENTERED";
            break;
         case 505:
            var1 = "MOUSE_EXITED";
            break;
         case 506:
            var1 = "MOUSE_DRAGGED";
            break;
         default:
            var1 = "unknown type";
      }

      return var1 + ",(" + this.field_0 + "," + this.field_1 + ")" + ",mods=" + ((InputEvent)this).getModifiers() + ",clickCount=" + this.clickCount;
   }

   static {
      NativeLibLoader.loadLibraries();
      initIDs();
   }
}
